---
title: 'HTML attribute: size'
slug: Web/HTML/Attributes/size
tags:
  - Attribute
  - HTML
  - Input
  - Reference
  - Select
---
<p>{{HTMLSidebar}}</p>

<p class="summary">The <strong><code>size</code></strong> attribute defines the width of the {{htmlelement('input')}} and the height of the {{htmlelement('select')}} element. For the <code>input</code>, if the <code>type</code> attribute is {{HTMLElement("input/text", "text")}} or {{HTMLElement("input/password", "password")}} then it's the number of characters. This must be an integer value 0 or higher. If no <code>size</code> is specified, or an invalid value is specified, the input has no size declared, and the form control will be the default width based on the user agent. If CSS targets the element with properties impacting the width, CSS takes precedence.</p>

<p>The <code>size</code> attribute has no impact on constraint validation.</p>

<h2 id="Examples">Examples</h2>

<p>By adding <code>size</code> on some input types, the width of the input can be controlled. Adding size on a select changes the height, definining how many options are visible in the closed state.</p>

<pre class="brush: html notranslate">&lt;label for="fruit"&gt;Enter a fruit&lt;/label&gt; &lt;input type="text" size="15" id="fruit"&gt;
&lt;label for="vegetable"&gt;Enter a vegetable&lt;/label&gt; &lt;input type="text" id="vegetable"&gt;

&lt;select name="fruits" size="5"&gt;
  &lt;option&gt;banana&lt;/option&gt;
  &lt;option&gt;cherry&lt;/option&gt;
  &lt;option&gt;strawberry&lt;/option&gt;
  &lt;option&gt;durian&lt;/option&gt;
  &lt;option&gt;blueberry&lt;/option&gt;
&lt;/select&gt;

&lt;select name="vegetables" size="5"&gt;
&lt;option&gt;carrot&lt;/option&gt;
&lt;option&gt;cucumber&lt;/option&gt;
&lt;option&gt;cauliflower&lt;/option&gt;
&lt;option&gt;celery&lt;/option&gt;
&lt;option&gt;collard greens&lt;/option&gt;
&lt;/select&gt;</pre>

<p>{{EmbedLiveSample('Examples', '100%', 200)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'input.html#attr-input-size', 'size attribute')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', 'input.html#attr-size-accept', 'size attribute')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.attribute.size")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/HTML/Attributes/maxlength">maxlength</a></code></li>
 <li><code><a href="/en-US/docs/Web/HTML/Attributes/minlength">minlength</a></code></li>
 <li><code><a href="/en-US/docs/Web/HTML/Attributes/pattern">pattern</a></code></li>
</ul>
